package com.bergerkiller.bukkit.nolagg;

import org.bukkit.entity.Item;
import org.bukkit.event.Event;
import org.bukkit.event.entity.CreatureSpawnEvent;
import org.bukkit.event.entity.CreatureSpawnEvent.SpawnReason;
import org.bukkit.event.entity.EntityDeathEvent;
import org.bukkit.event.entity.EntityExplodeEvent;
import org.bukkit.event.entity.EntityListener;
import org.bukkit.event.entity.ItemSpawnEvent;

import com.all.bukkit.threadcheck.ThreadCheck;
import com.bergerkiller.bukkit.nolagg.meta.WorldMetaData;
import com.bergerkiller.bukkit.nolagg.spawnlimit.SpawnHandler;

public class NLEntityListener extends EntityListener {
	
	@Override
	public void onItemSpawn(ItemSpawnEvent event) {
		if (!ThreadCheck.check(Event.Type.CUSTOM_EVENT)) return;
		if (event.isCancelled()) return;
		if (ItemHandler.isIgnoredItem(event.getEntity())) return;
		if (SpawnHandler.handleSpawn(event)) {
			if (WorldMetaData.handleItemSpawn((Item) event.getEntity(), false)) {
				if (ItemHandler.formStacks) {
					//StackFormer.stackNear((Item) event.getEntity());
				}
			} else {
				event.setCancelled(true);
			}
		}
	}
	
	@Override
	public void onCreatureSpawn(CreatureSpawnEvent event) {
		if (!ThreadCheck.check(Event.Type.CUSTOM_EVENT)) return;
		if (event.getSpawnReason() == SpawnReason.CUSTOM) {
			SpawnHandler.ignoreSpawn(event.getEntity());
		} else {
			SpawnHandler.handleSpawn(event);
		}
	}
		
	@Override
	public void onEntityExplode(EntityExplodeEvent event) {
		if (!ThreadCheck.check(Event.Type.CUSTOM_EVENT)) return;
		if (!event.isCancelled()) {
			if (TnTHandler.createExplosion(event)) {
				//I know, we monitor, but the end result is the same anyway!
				event.setCancelled(true);
			}
		}
	}
	
	@Override
	public void onEntityDeath(EntityDeathEvent event) {
		if (!ThreadCheck.check(Event.Type.CUSTOM_EVENT)) return;
		SpawnHandler.handleDespawn(event.getEntity());
	}
	
}
